// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlSettingsFlagAction")]
    pub struct SettingsFlagAction(Object<ffi::DzlSettingsFlagAction, ffi::DzlSettingsFlagActionClass>) @implements gio::Action;

    match fn {
        type_ => || ffi::dzl_settings_flag_action_get_type(),
    }
}

impl SettingsFlagAction {
    #[doc(alias = "flag-nick")]
    pub fn flag_nick(&self) -> Option<glib::GString> {
        ObjectExt::property(self, "flag-nick")
    }

    #[doc(alias = "schema-id")]
    pub fn schema_id(&self) -> Option<glib::GString> {
        ObjectExt::property(self, "schema-id")
    }

    #[doc(alias = "schema-key")]
    pub fn schema_key(&self) -> Option<glib::GString> {
        ObjectExt::property(self, "schema-key")
    }

    #[doc(alias = "schema-key")]
    pub fn set_schema_key(&self, schema_key: Option<&str>) {
        ObjectExt::set_property(self, "schema-key", schema_key)
    }

    #[doc(alias = "dzl_settings_flag_action_new")]
    pub fn new(schema_id: &str, schema_key: &str, flag_nick: &str) -> Option<gio::Action> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_full(ffi::dzl_settings_flag_action_new(
                schema_id.to_glib_none().0,
                schema_key.to_glib_none().0,
                flag_nick.to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "schema-key")]
    pub fn connect_schema_key_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_schema_key_trampoline<F: Fn(&SettingsFlagAction) + 'static>(
            this: *mut ffi::DzlSettingsFlagAction,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::schema-key\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_schema_key_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for SettingsFlagAction {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("SettingsFlagAction")
    }
}
